#ifndef _MOMENTUMDEF_H_INCLUDED_
#define _MOMENTUMDEF_H_INCLUDED_
#include "WJets.h"
#define new 1
#define new2 1
extern int MDtemp[48][8];
typedef void (*tpMGfunc)(FREAL * , FREAL *);
#if new
/* typedef std::vector<int> tpmomshuffle; */
typedef int tpmomshuffle;
struct sPMchoice // Structure for Process and Momentum choice
{
  tpMGfunc MGfunc;
  bool ptype; // p(0) or q(1)?
  /* std::vector<tpmomshuffle> MomShuffleVector; */
  std::vector<int> MomShuffleVector;
  int idpartmult;
};
#else
typedef void (*tpmompick)(double [][4], double [][4], particle*, particle *);
struct sPMchoice // Structure for Process and Momentum choice
{
  tpMGfunc MGfunc;
  std::vector<tpmompick> MomPickVector;
  int idpartmult;
};
#endif
void Def4jp1(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp2(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp3(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp4(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp5(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp6(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp7(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp8(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp9(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp10(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp11(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp12(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp13(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp14(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp15(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp16(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp17(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp18(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp19(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp20(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp21(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp22(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp23(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp24(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp25(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp26(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp27(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp28(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp29(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp30(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp31(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp32(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp33(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp34(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp35(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp36(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp37(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp38(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp39(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp40(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp41(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp42(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp43(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp44(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp45(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp46(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp47(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
void Def4jp48(double in[][4],double pmg[][4],particle * lepton, particle * alepton);
double PickAndEvalProcAndMom2j(std::vector<sPMchoice> NonFKLProcesses, double p[6][4], particle * lepton, particle * alepton);
double PickMomAndEval2j(std::vector<sPMchoice> NonFKLProcesses, double p[6][4], particle * lepton, particle * alepton);
double PickProcAndEval2j(std::vector<sPMchoice> NonFKLProcesses, double p[6][4], particle * lepton, particle * alepton);
double NoPickButEval2j(std::vector<sPMchoice> NonFKLProcesses, double p[6][4], particle * lepton, particle * alepton);
double PickAndEvalProcAndMom3j(std::vector<sPMchoice> NonFKLProcesses, double p[7][4], particle * lepton, particle * alepton);
double PickMomAndEval3j(std::vector<sPMchoice> NonFKLProcesses, double p[7][4], particle * lepton, particle * alepton);
double PickAndEvalProcAndMom4j(std::vector<sPMchoice> NonFKLProcesses, double p[8][4], particle * lepton, particle * alepton);
#endif
